#include<iostream>
#include<vector>
using namespace std;
#define ll long long
const ll MAXN=1e5+6;
const ll mod=1e9+7;
void fastIO()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
}
int n,k;
ll ans;
ll val[MAXN];
ll tl[MAXN];
ll dp[MAXN];
ll to_num(string s)
{
    ll res=0;
    for(int i=0;i<s.size();i++)
    {
        res=res*2ll;
        if(s[i]=='1')res++;
    }
    return res;
}
ll pref_and[MAXN];
ll suf_and[MAXN];
ll get_pref(int ind)
{
    if(ind<0)return (1ll<<k)-1;
    return pref_and[ind];
}
ll get_suf(int ind)
{
    if(ind>n-1)return (1ll<<k)-1;
    return suf_and[ind];
}
ll fastpow(ll x,ll p)
{
    if(p==0)return 1;
    if(p==1)return x;
    ll t=fastpow(x,p/2);
    t*=t;
    t%=mod;
    if(p%2==1)
    {
        t*=x;
        t%=mod;
    }
    return t;
}
int main()
{
    fastIO();
    cin>>n>>k;
    for(int i=0;i<n;i++)
    {
        string s;
        cin>>s;
        val[i]=to_num(s);
        val[i+n]=val[i];
    }
    ll cur=(1ll<<(k+1))-1;
    ll and_all=cur;
    for(int i=0;i<n;i++)and_all=(and_all&val[i]);
    for(int j=0;j<2*n;j++)
    {
        cur=(1ll<<(k+1))-1;
        for(int i=j;i>=0;i--)
        {
            cur&=val[i];
            if(cur==0)
            {
                tl[j]=i+1;
                break;
            }
        }
    }
    pref_and[0]=val[0];
    suf_and[n-1]=val[n-1];
    for(int i=1;i<n;i++)pref_and[i]=(pref_and[i-1]&val[i]);
    for(int i=n-2;i>=0;i--)suf_and[i]=(suf_and[i+1]&val[i]);
    ll ans=0;
    if(and_all!=0)ans++;
    //cout<<and_all<<endl;
    for(int l1=1;l1<n;l1++)
    {
        for(int r1=l1;r1<n-1;r1++)
        {
            if(l1==0&&r1==n-1)continue;
            if(get_pref(l1-1)&get_suf(r1+1))
            {
                for(int i=0;i<2*n;i++)
                {
                    dp[i]=0;
                }
                dp[l1]=1;
                for(int i=l1+1;i<=r1;i++)
                {
                    dp[i]=2ll*dp[i-1];dp[i]%=mod;
                    if(tl[i]>l1&&tl[i]!=tl[i-1])dp[i]+=mod-dp[tl[i]-1];
                    dp[i]%=mod;
                }
                ans+=dp[r1];
                ans%=mod;
                //cout<<l1<<" "<<r1<<" "<<dp[r1]<<endl;
            }
        }
    }
    ll ans1=0;
    for(int l1=0;l1<n;l1++)
    {
        for(int r1=l1;r1<n;r1++)
        {
            if(l1==0&&r1==n-1)continue;
            if(l1>0&&r1<n-1)continue;
            if(get_pref(l1-1)&get_suf(r1+1))
            {
                for(int i=0;i<2*n;i++)
                {
                    dp[i]=0;
                }
                dp[l1]=1;
                for(int i=l1+1;i<=r1;i++)
                {
                    dp[i]=2ll*dp[i-1];dp[i]%=mod;
                    if(tl[i]>l1&&tl[i]!=tl[i-1])dp[i]+=mod-dp[tl[i]-1];
                    dp[i]%=mod;
                }
                ans1+=dp[r1];
                ans1%=mod;
                //cout<<l1<<" "<<r1<<" "<<dp[r1]<<endl;
            }
        }
    }
    ans1*=fastpow(2,mod-2);
    ans1%=mod;
    //cout<<ans<<endl;
    ans+=ans1;ans%=mod;
    cout<<ans<<endl;
return 0;
}
