///#include "Lgrader.cpp"
#include "maxpath.h"
#include <iostream>
#include <random>
#define endl '\n'
using namespace std;

mt19937 rg(15034813);

int n;
int v1, v2;
int dist[200005];
vector<int> vec[200005];

int ask_judge(int a, int b);

void learn(int n0)
{
    n = n0;
    int u = rg() % n + 1;
    do
    {
        for (int d = 1; d <= n; ++ d)
        {
            vec[d].clear();
        }
        int d0 = 0;
        for (int v = 1; v <= n; ++ v)
        {
            if (v == u) continue;
            int d = ask_judge(u, v);
            vec[d].push_back(v);
            if (vec[d].size() > 1) d0 = d;
        }
        if (d0 == 0) break;
        u = vec[d0][rg() % vec[d0].size()];
    } while (true);

    v1 = u, v2 = vec[1][0];
    for (int d = 2; d < n; ++ d)
    {
        dist[vec[d][0]] = d;
    }
}

int ask_contestant(int a, int b)
{
    if ((a == v1 and b == v2) or (a == v2 and b == v1)) return 1;
    if (a == v1 or a == v2) return dist[b];
    if (b == v1 or b == v2) return dist[a];
    return max(dist[a], dist[b]);
}
