///#include "Lgrader.cpp"
#include "maxpath.h"
#include <iostream>
#include <utility>
#include <random>
#include <vector>
#include <queue>
#define endl '\n'
using namespace std;

const int MAXN = 200000;

mt19937 rg(15034813);

struct group
{
    int par, edge;
    vector<int> vert;
};

int n;
int d[2 * MAXN + 5];
vector< pair<int, int> > G[2 * MAXN + 5];

int add_edge(int u, int v, int w)
{
    G[u].push_back({v, w});
    G[v].push_back({u, w});
}

int ask_judge(int a, int b);

void learn(int n0)
{
    n = n0;
    group g;
    g.par = g.edge = 0;
    g.vert.clear();
    queue<group> active;
    for (int i = 1; i <= n; ++ i)
    {
        g.vert.push_back(i);
    }
    active.push(g);

    int nv = n;
    while (!active.empty())
    {
        g = active.front();
        active.pop();
        int u = g.vert[rg() % g.vert.size()];
        int mx = 0;
        for (auto v : g.vert)
        {
            if (u == v) continue;
            d[v] = ask_judge(u, v);
            mx = max(mx, d[v]);
        }
        /**while (true)
        {
            int mx2 = 0;
            group g1, g2;
            g1.par = g1.edge = g2.par = g2.edge = 0;
            g1.vert.clear(); g2.vert.clear();
            for (auto v : g.vert)
            {
                if (u != v and d[v] == mx) g2.vert.push_back(v);
                else
                {
                    g1.vert.push_back(v);
                    if (u != v) mx2 = max(mx2, d[v]);
                }
            }
            nv++;
            if (g.par != 0) add_edge(g.par, nv, g.edge);
            if (g2.vert.size() == 1) add_edge(g2.vert[0], nv, mx);
            else
            {
                g2.par = nv;
                g2.edge = mx;
                active.push(g2);
            }
            if (g1.vert.size() == 1)
            {
                add_edge(g1.vert[0], nv, mx);
                break;
            }
            else
            {
                g1.par = nv;
                g1.edge = mx2;
                g = g1;
                mx = mx2;
            }
        }*/
    }
}

int ask_contestant(int a, int b)
{
    return 1;
}
