#include <bits/stdc++.h>
#include "maxpath.h"
using namespace std;

const int MAXN = 2e5+5;
int N;

int tree[4 * MAXN];
void update(int L, int R, int node, int ind, int val)
{
    if (L > ind || R < ind) return;
    if (L == R)
    {
        tree[node] += val;
        return;
    }
    int mid = (L + R) / 2;

    update(L, mid, node*2, ind, val);
    update(mid+1, R, node*2+1, ind, val);

    tree[node] = max(tree[node*2],  tree[node*2+1]);
}

int query(int L, int R, int node, int beg, int en)
{
    if (L > en || R < beg) return 0;
    if (L >= beg && R <= en) return tree[node];
    int mid = (L+R)/2;
    return max(query(L, mid, node*2, beg, en), query(mid+1, R, node*2+1, beg, en));
}

map <pair<int,int>, int> mp;
int root;

void learn(int n)
{
    N = n;
    for (int i = 1; i <= n; i++)
    {
        int prev = 0;
        bool fl = 0;
        int pos = 0;
        for (int j = 1; j <= n; j++)
        {
            if (j == i) continue;
            int p = ask_judge(i, j);
            mp[{i, j}] = p;
            mp[{j, i}] = p;
            if (p == 1) pos = j;
            if (p == prev)
            {
                fl = 1;
                break;
            }
        }
        if (fl) continue;

        root = i;
        i = pos;

        break; ///

        for (int j = 1; j <= n; j++)
        {
            if (j == i) continue;
            int p = ask_judge(i, j);
            mp[{i, j}] = p;
            mp[{j, i}] = p;
            if (p == 1) pos = j;
            if (p == prev)
            {
                fl = 1;
                break;
            }
        }

        if (!fl) root = i;

        break;
    }
}

int ask_contestant(int a, int b)
{
    if (a > b) swap(a, b);
    return max(mp[{a,root}], mp[{b,root}]);
}
