#include <vector>
#include <utility>
#include <iostream>
#include <cassert>
using namespace std;

int bin[2002000];
int dp[2020][2020];

void build(ll pos,ll l,ll r){
  if(l==r){
    bin[pos]=ask_judge(l,l+1);
    return ;
    }
  
  int mid=(l+r)/2;
  build(pos*2,l,mid);
  build(pos*2+1,mid-1,r);
  return ;
  }

int q(ll pos,ll l,ll r,ll ql,ll qr){
  if(l>=ql && r<=qr)return bin[pos];
  if(l>qr || r<ql)return 0;
  
  int mid=(l+r)/2;
  int p1=q(pos*2,l,mid,ql,qr);
  int p2=q(pos*2+1,mid+1,r,ql,qr);
  return max(p1,p2);
  }
  
void learn(int n){
  build(1,1,n-1);
  }

int ask_contestant(int a, int b){
  return q(1,1,n-1,a,b-1);
  }

//int main(){return 0;}
