#include<bits/stdc++.h>
#define endl '\n'
#include "maxpath.h"
using namespace std;
const int MAX_N = 2e5+2;
int w0;
vector< pair<int,int> > path[MAX_N];
void decompose(vector<int> a)
{
    if(a.size() == 2)
    {
        w0 = ask_judge(a[0],a[1]);
        path[a[0]].push_back({0,w0});
        path[a[1]].push_back({1,w0});
    }
    else
    {
        int max_edge = 0;
        vector<int> temp;
        vector<int> temp2;
        for(int i=1; i<a.size(); i++)
        {
            w0 = ask_judge(a[0],a[i]);
            if(w0 == max_edge)
            {
                temp.push_back(a[i]);
            }
            else if(w0 > max_edge)
            {
                temp.clear();
                temp.push_back(a[i]);
                max_edge = w0;
            }
        }
        int ptr = 0;
        for(int i=0; i<a.size(); i++)
        {
            if(ptr < temp.size())
            {
                if(temp[ptr] == a[i])
                {
                    ptr++;
                }
                else
                {
                    temp2.push_back(a[i]);
                }
            }
        }
        for(int i=0; i<temp.size(); i++)
        {
            path[temp[i]].push_back({0,max_edge});
        }
        for(int i=0; i<temp2.size(); i++)
        {
            path[temp2[i]].push_back({1,max_edge});
        }
        if(temp.size() > 1) decompose(temp);
        if(temp2.size() > 1) decompose(temp2);
    }
}
void learn(int n)
{
    vector<int> tmp;
    for(int i=1; i<=n; i++)
    {
        tmp.push_back(i);
    }
    decompose(tmp);
}
int ask_contestant(int a, int b)
{
    for(int i=0; ;i++)
    {
        if(path[a][i].first != path[b][i].first)
        {
            return path[a][i].second;
        }
    }
}
