#include<bits/stdc++.h>
#include "maxpath.h"
#define MAXN1 2002
#define MAXN2 2000002
using namespace std;
int all[MAXN1][MAXN1], caseNum, st[MAXN2][64], N;
int path[MAXN2];
void case1()
{
    for(int i = 1; i <= N; i ++)
    {
        for(int j = 1; j <= N; j ++)
        {
            if(i != j) all[i][j] = all[j][i] = ask_judge(i, j);
        }
    }
}
void case2()
{
    for(int i = 2; i <= N; i ++)
    {
        path[i] = ask_judge(i, i - 1);
    }
}
void build_sparse()
{
    for(int i = 1; i <= N; i ++) st[i][0] = path[i];
    for(int i = 1; (1 << i) <= N; i ++)
    {
        for(int j = 1; j + (1 << i) - 1 <= N; j ++)
        {
            st[j][i] = max(st[j][i - 1], st[j + (1 << (i - 1))][i - 1]);
        }
    }
}
int findPW(int p)
{
    int pw = 0;
    while(p)
    {
        pw ++;
        p /= 2;
    }
    return pw - 1;
}
int sparse_queries(int l, int r)
{
    int sz = findPW(sz);
    return max(st[l][sz], st[N - (1 << (sz)) + 1][sz]);
}
void learn(int n)
{
    //cout<<findPW(0)<<endl;
    N = n;
    if(n < MAXN1)
    {
        case1();
        caseNum = 1;
    }
    else
    {
        case2();
        caseNum = 2;
        build_sparse();
    }

}
int ask_contestant(int a, int b)
{
    if(caseNum == 1) return all[a][b];
    else return sparse_queries(a, b);
}
