#include "maxpath.h"
#include <algorithm>
#include <vector>
#include <iostream>
#include <random>
#include <set>
using namespace std;
const int MAXN=2e5+6;
bool found[MAXN];
int weight[MAXN];
int where[MAXN];
vector<int>neshta[MAXN];
int l[MAXN],r[MAXN];
struct segment_tree
{
    int tree[4*MAXN];
    void build(int l,int r,int idx)
    {
        if(l==r)
        {
            tree[idx]=weight[l];
            return;
        }
        int mid=(l+r)/2;
        build(l,mid,idx*2);
        build(mid+1,r,idx*2+1);
        tree[idx]=max(tree[idx*2],tree[idx*2+1]);
    }
    int query(int l,int r,int idx,int ql,int qr)
    {
        if(l>qr)return 0;
        if(r<ql)return 0;
        if(l>=ql&&r<=qr)return tree[idx];
        int mid=(l+r)/2;
        return max(query(l,mid,idx*2,ql,qr),query(mid+1,r,idx*2+1,ql,qr));
    }
}tr;
int n1;
int val[MAXN];
void learn(int n)
{
    n1=n;
    srand(34543);
    vector<int>remaining;

    for(int i=1;i<=n;i++)
    {
        val[i]=-1;
        remaining.push_back(i);
    }
    for(;;)
    {
        if(remaining.size()<=1)break;
        if(remaining.size()==2)
        {
            val[remaining[0]]=1;
            val[remaining[1]]=1;
            break;
        }
        int t=rand()%remaining.size();
        vector<pair<int,int> >lmao;
        int minw=n;
        for(int j=0;j<remaining.size();j++)
        {
            if(j==t)continue;
            lmao.push_back({ask_judge(remaining[t],remaining[j]),remaining[j]});
            minw=min(minw,lmao.back().first);
        }
        for(int i=0;i<lmao.size();i++)
        {
            if(lmao[i].first==minw)continue;
            val[lmao[i].second]=lmao[i].first;
        }
        remaining.clear();
        for(int i=1;i<=n;i++)
        {
            if(val[i]==-1)remaining.push_back(i);
        }
    }
}

int ask_contestant(int a,int b)
{
    return max(val[a],val[b]);
}
