#include "maxpath.h"
#include <algorithm>
#include <vector>
#include <iostream>
using namespace std;
const int MAXN=2e5+6;
bool found[MAXN];
int weight[MAXN];
int where[MAXN];
vector<int>neshta[MAXN];
int l[MAXN],r[MAXN];
struct segment_tree
{
    int tree[4*MAXN];
    void build(int l,int r,int idx)
    {
        if(l==r)
        {
            tree[idx]=weight[l];
            return;
        }
        int mid=(l+r)/2;
        build(l,mid,idx*2);
        build(mid+1,r,idx*2+1);
        tree[idx]=max(tree[idx*2],tree[idx*2+1]);
    }
    int query(int l,int r,int idx,int ql,int qr)
    {
        if(l>qr)return 0;
        if(r<ql)return 0;
        if(l>=ql&&r<=qr)return tree[idx];
        int mid=(l+r)/2;
        return max(query(l,mid,idx*2,ql,qr),query(mid+1,r,idx*2+1,ql,qr));
    }
}tr;
int n1;
void learn(int n)
{
    n1=n;
    for(int i=1;i<=n;i++)
    {
        where[i]=i;
        if(i<n)weight[i]=ask_judge(i,i+1);
    }
    tr.build(1,n-1,1);
    /*for(int i=1;i<=n;i++)
    {
        cout<<i<<": "<<where[i]<<endl;
    }
    for(int i=1;i<n;i++)cout<<weight[i]<<" ";
    cout<<endl;*/
}

int ask_contestant(int a,int b)
{
    int ind1=where[a];
    int ind2=where[b];
    if(ind1>ind2)swap(ind1,ind2);
    ind2--;
    return tr.query(1,n1-1,1,ind1,ind2);
}
