#include<bits/stdc++.h>
#include "maxpath.h"
using namespace std;

const int MAXN=2e5+5;

int n;
int w[MAXN];
int tree[4*MAXN];

void update(int node,int l,int r,int pos,int val)
{
    if(l==r)
    {
        tree[node]=val;
        return;
    }
    int mid=(l+r)/2;
    if(pos<=mid) update(2*node,l,mid,pos,val);
    else update(2*node+1,mid+1,r,pos,val);
    tree[node]=max(tree[2*node],tree[2*node+1]);
}

int query(int node,int l,int r,int ql,int qr)
{
    if(ql<=l && r<=qr) return tree[node];
    int mid=(l+r)/2;
    int ret=0;
    if(ql<=mid) ret=max(ret,query(2*node,l,mid,ql,qr));
    if(qr>mid) ret=max(ret,query(2*node+1,mid+1,r,ql,qr));
    return ret;
}

void learn(int N)
{
    n=N;
    for(int i=1;i<n;i++)
    {
        w[i]=ask_judge(i,i+1);
        update(1,1,n-1,i,w[i]);
    }
}

int ask_contestant(int a,int b)
{
    if(a>b) swap(a,b);
    return query(1,1,n-1,a,b-1);
}
