#include<iostream>
#include<algorithm>
#include "maxpath.h"
#include<cmath>
using namespace std;

const int MAXN=2e3;
const int MAXLOG=ceil(log2(MAXN))+1;

int sPaths[MAXN];
int rmq[MAXN][MAXLOG];
int ans[MAXN][MAXN];

void BuildRMQ(int n)
{
    int l=log2(n);
    for(int i=0; i<=l; i++)
    {
        for(int j=0; j+(1<<i)<=n; j++)
        {
            if(i==0)
            {
                rmq[j][i]=sPaths[j];
            }
            else
            {
                rmq[j][i]=max(rmq[j][i-1], rmq[j+(1<<(i-1))][i-1]);
            }
        }
    }

    return;
}

void learn(int n)
{
    for(int i=0; i<n-1; i++)
    {
        for(int j=i+1; j<n; j++)
        {
            ans[i][j]=ask_judge(i+1, j+1);
        }
    }

    //BuildRMQ(n);

    return;
}

int ask_contestant(int a, int b)
{
    a--, b--;

    if(a>b)
    {
        swap(a, b);
    }

    return ans[a][b];

    int l=log2(b-a);
    return max(rmq[a][l], rmq[b-(1<<l)][l]);
}
