#include<iostream>
#include<algorithm>
#include "maxpath.h"
#include<vector>
#include<cmath>
#include<set>
using namespace std;

const int MAXN=2e5;
int ans[MAXN];
bool isRoot[MAXN];
int root=-1;

void learn(int n)
{
    for(int i=0; i<n; i++)
    {
        isRoot[i]=true;
    }

    while(true)
    {
        vector<int> v;
        for(int i=0; i<n; i++)
        {
            if(isRoot[i])
            {
                v.push_back(i);
            }
        }
        random_shuffle(v.begin(), v.end());

        int idx=v[0], node=-1;
        set<int> st;
        for(int i=0; i<n; i++)
        {
            if(i==idx || !isRoot[i])
            {
                ans[i]=-1;
                continue;
            }

            ans[i]=ask_judge(i+1, idx+1);

            if(st.count(ans[i])!=0)
            {
                node=ans[i];
            }
            else
            {
                st.insert(ans[i]);
            }
        }

        if(node==-1)
        {
            root=idx;
            break;
        }
        else
        {
            for(int i=0; i<n; i++)
            {
                if(ans[i]!=node)
                {
                    isRoot[i]=false;
                }
            }
        }
    }

    for(int i=0; i<n; i++)
    {
        if(i!=root)
        {
            ans[i]=ask_judge(i+1, root+1);
        }
        else
        {
            ans[i]=0;
        }
    }

    return;
}

int ask_contestant(int a, int b)
{
    a--, b--;

    return max(ans[a], ans[b]);
}
