#include<iostream>
using namespace std;

const int MAXN=1e5, MAXK=60, MOD=1e9+7;

long long masks[MAXN];
long long groups[MAXN];

long long GetAns(int n, int k, int idx, long long mask, int groupIdx)
{
    if(idx==n-1)
    {
        if(groupIdx==0)
        {
            return 1;
        }

        int same=0, different=0;
        long long combinedMask=mask&groups[0];
        for(int i=0; i<k; i++)
        {
            if(((1<<i)&combinedMask)!=0)
            {
                same=1;
            }
            else
            {
                different=1;
            }
        }

        return same+different;
    }

    long long combinedMask=mask&masks[idx+1];
    long long ans=0;
    if(combinedMask!=0)
    {
        ans=(ans+GetAns(n, k, idx+1, combinedMask, groupIdx))%MOD;
    }

    if(combinedMask!=((1<<k)-1))
    {
        groups[groupIdx]=mask;

        ans=(ans+GetAns(n, k, idx+1, masks[idx+1], groupIdx+1))%MOD;
    }

    return ans;
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int n, k;
    cin >> n >> k;

    for(int i=0; i<n; i++)
    {
        string s;
        cin >> s;
        for(int j=0; j<k; j++)
        {
            masks[i]=(masks[i]<<1);
            if(s[j]=='1')
            {
                masks[i]|=1;
            }
        }
    }

    cout << GetAns(n, k, 0, masks[0], 0) << "\n";

    return 0;
}
