#include<bits/stdc++.h>
#include "maxpath.h"
#define MAXN 200007
using namespace std;

int n,pos[MAXN];
vector<int> v,s;
vector< pair<int,int> > rod[MAXN];

int dsu[MAXN],l[MAXN],r[MAXN];

int root(int x){
    if(dsu[x]==x)return x;
    dsu[x]=root(dsu[x]);
    return dsu[x];
}

void add_edge(int x,int y,int z){
    //cout<<x<<" "<<y<<" "<<z<<"\n";
    rod[x].push_back({y,z});
    rod[y].push_back({x,z});
}

void mergev(int x,int y,int z){
    add_edge(r[root(x)],l[root(y)],z);
    l[root(y)]=l[root(x)];
    dsu[root(x)]=root(y);
}

void solve(vector<int> v){
    if(v.size()==1)return;

    int r=v[rand()%int(v.size())];
    vector< pair<int,int> > pairs={};
    for(int i:v){
        if(i==r)continue;
        pairs.push_back({ask_judge(i,r),i});
    }
    pairs.push_back({0,r});
    sort(pairs.begin(),pairs.end());

    vector<int> w={};
    for(int i=0;i<pairs.size();i++){
        w.push_back(pairs[i].second);
        if(i<pairs.size()-1 and pairs[i].first!=pairs[i+1].first){
            solve(w); w.clear();
        }
    }
    solve(w); w.clear();
    for(int i=0;i<pairs.size()-1;i++){
        if(pairs[i].first!=pairs[i+1].first){
            mergev(pairs[i].second,pairs[i+1].second,pairs[i+1].first);
        }
    }
}

void dfs(int x,int p){
    pos[x]=int(s.size());
    for(int i=0;i<rod[x].size();i++){
        if(rod[x][i].first==p)continue;
        s.push_back(rod[x][i].second);
        dfs(rod[x][i].first,x);
    }
}

void learn(int N){
    n=N;
    for(int i=1;i<=n;i++){
        v.push_back(i);
        dsu[i]=l[i]=r[i]=i;
    }
    solve(v);
    for(int i=1;i<=n;i++){
        if(rod[i].size()==1){
            dfs(i,0); break;
        }
    }
}

int ask_contestant(int a,int b){
    int res=0;
    if(pos[a]>pos[b])swap(a,b);

    for(int i=pos[a];i<=pos[b]-1;i++){
        res=max(res,s[i]);
    }
    return res;
}

