#include "maxpath.h"

#include <bits/stdc++.h>
using namespace std;
#ifndef LOCAL
#define cerr if(false)cerr
#endif // LOCAL
#define endl "\n"
template<class T, class T2> bool chkmin(T &a, const T2 &b) { return (a > b) ? a = b, 1 : 0; }
template<class T, class T2> bool chkmax(T &a, const T2 &b) { return (a < b) ? a = b, 1 : 0; }
typedef long long ll;
const ll mod = 1e9 + 7;

const int MAX_N = 2e5 + 10, LOG = 18;
vector<int> g[MAX_N];
pair<int, int> par[MAX_N][LOG];
int d[MAX_N], aux;

void dfs(vector<int> &all, int p, int w) {
    if(all.size() == 1) {
        int x = all[0];
        par[x][0] = {p, w};
        d[x] = d[p] + 1;
        for(int i = 1; i < LOG; i ++) {
            const int mid = par[x][i - 1].first;
            par[x][i] = {par[mid][i - 1].first, max(par[x][i - 1].second, par[mid][i - 1].second)};
        }
        return;
    }

    int x = aux ++;
    par[x][0] = {p, w};
    d[x] = d[p] + 1;
    for(int i = 1; i < LOG; i ++) {
        const int mid = par[x][i - 1].first;
        par[x][i] = {par[mid][i - 1].first, max(par[x][i - 1].second, par[mid][i - 1].second)};
    }

    int some = -1;
    for(auto it : all) {
        if(some == -1 || g[it].size() > g[some].size()) {
            some = it;
        }
    }

    vector<pair<int, int> > close;
    for(auto it : all) if(it != some) {
        close.push_back({ask_judge(some, it), it});
    }
    close.push_back({0, some});

    int mx = (*max_element(close.begin(), close.end())).first;

    vector<int> lft, rght;
    for(auto it : close) {
        if(it.first == mx) {
            lft.push_back(it.second);
        } else {
            rght.push_back(it.second);
        }
    }
    dfs(move(lft), x, mx);
    dfs(move(rght), x, 0);
}

void learn(int n) {
    aux = n + 1;

    vector<int> all = {};
    for(int i = 1; i <= n; i ++) {
        all.push_back(i);
    }
    dfs(all, 0, 0);

    return;
}

int ask_contestant(int a, int b) {
    int ret = 0;

    if(d[a] < d[b]) { swap(a, b); }
    for(int i = LOG - 1; i >= 0; i --) {
        if(d[par[a][i].first] >= d[b]) {
            chkmax(ret, par[a][i].second);
            a = par[a][i].first;
        }
    }

    if(a == b) { return ret; }

    for(int i = LOG - 1; i >= 0; i --) {
        if(par[a][i].first != par[b][i].first) {
            chkmax(ret, par[a][i].second);
            chkmax(ret, par[b][i].second);
            a = par[a][i].first;
            b = par[b][i].first;
        }
    }

    chkmax(ret, par[a][0].second);
    chkmax(ret, par[b][0].second);
    return ret;
}

/*
3
1 2
2
3
1 2
1 3
2 3
*/
