#include <bits/stdc++.h>
using namespace std;
#ifndef LOCAL
#define cerr if(false)cerr
#endif // LOCAL
#define endl "\n"
template<class T, class T2> bool chkmin(T &a, const T2 &b) { return (a > b) ? a = b, 1 : 0; }
template<class T, class T2> bool chkmax(T &a, const T2 &b) { return (a < b) ? a = b, 1 : 0; }
typedef long long ll;
const ll mod = 1e9 + 7;

const ll MAX_N = 1e6 + 10, MAX_K = 60;

ll total[MAX_K];
string cnt[MAX_N];
ll bad = 0;
ll n, k;
ll lft[MAX_N];

void add(ll x, ll delta = 1) {
    for(ll i = 0; i < k; i ++) {
        if(total[i] != 0) { bad --; }
        total[i] += (cnt[x][i] == '0') * delta;
        if(total[i] != 0) { bad ++; }
    }
}

ll dp[MAX_N];

ll solve(ll starting) {
    for(ll i = 0; i <= n; i ++) {
        dp[i] = 0;
    }
    dp[0] = 1;
    for(ll i = 1; i <= n; i ++) {
        if(cnt[i][starting] == '1') {
            dp[i] = 1;
        } else {
            break;
        }
    }
    for(ll i = 1; i <= n; i ++) {
        for(ll j = lft[i]; j < i; j ++) {
            dp[i] = (dp[i] + dp[j - 1]) % mod;
        }
    }

    // TODO: Check for all
    ll ret = 0;
    for(ll i = n; i >= 1; i --) {
        ret = (ret + dp[i]) % mod;
        if(i != 0 && cnt[i][starting] == '0') {
            break;
        }
    }
    return ret;
}

signed main() {
#ifndef LOCAL
    ios_base::sync_with_stdio(false); cin.tie(NULL);
#endif // LOCAL

    cin >> n >> k;
    for(ll i = 1; i <= n; i ++) {
        cin >> cnt[i];
    }

    ll l = 1;
    for(ll r = 1; r <= n; r ++) {
        add(r, 1);
        while(bad == k) {
            add(l, -1);
            l ++;
        }
        lft[r] = l;
    }

    ll ret = 0;
    for(ll i = 0; i < k; i ++) {
        ret = (ret + solve(i)) % mod;
    }
    cout << ret << endl;

    return 0;
}

