#include <bits/stdc++.h>
using namespace std;
#ifndef LOCAL
#define cerr if(false)cerr
#endif // LOCAL
#define endl "\n"
template<class T, class T2> bool chkmin(T &a, const T2 &b) { return (a > b) ? a = b, 1 : 0; }
template<class T, class T2> bool chkmax(T &a, const T2 &b) { return (a < b) ? a = b, 1 : 0; }
typedef long long ll;
const ll mod = 1e9 + 7;

const ll MAX_N = 1e6 + 10, MAX_K = 60;

ll total[MAX_K];
string cnt[MAX_N];
ll bad = 0;
ll n, k;
ll lft[MAX_N];

set<int> good;

void add(ll x, ll delta = 1) {
    for(ll i = 0; i < k; i ++) {
        if(total[i] != 0) {
            good.insert(i);
        }
        total[i] += (cnt[x][i] == '0') * delta;
        if(total[i] != 0) {
            good.erase(i);
        }
    }
}

void reset() {
    for(int i = 0; i < k; i ++) {
        good.insert(i);
        total[i] = 0;
    }
}

ll dp[MAX_N], pref[MAX_N];

int starting[MAX_N];

ll fpow(ll x, ll p) {
    if(p == 0) { return 1; }
    ll ans = fpow(x, p / 2);
    ans = (ans * ans) % mod;
    if(p & 1) {
        return (ans * x) % mod;
    } else {
        return ans;
    }
}

ll solve(ll start) {
    if(starting[n] == start) {
        cout << (fpow(2, n) - n + mod) % mod << endl;
        exit(0);
    }

    for(int i = 0; i <= n; i ++) {
        dp[i] = 0;
    }

    for(int i = 1; i <= n; i ++) {
        if(starting[i] == start) {
            dp[i] = 1;
        } else {
            break;
        }
    }

    for(int i = 1; i <= n; i ++) {
        for(int j = lft[i]; j <= i; j ++) {
            dp[i] = (dp[i] + dp[j - 1]) % mod;
        }
        cout << dp[i] << " ";
    }
    cout << endl;

    ll ret = 0;
    for(int i = n; i >= 0; i --) {
        ret = (ret + dp[i]) % mod;
        if(cnt[i][start] == '0') {
            break;
        }
    }

    return ret;
}

ll solve_slow(int start) {
    for(int i = 0; i <= 2 * n; i ++) {
        dp[i] = 0;
        pref[i] = 0;
    }
    dp[start - 1] = 1;
    pref[start - 1] = 1;
    for(int i = start; i < start + n; i ++) {
        if(lft[i] == 1) {
            dp[i] = (dp[i] + pref[min(n, (ll)i) - 1]) % mod;
        } else {
            dp[i] = (dp[i] + pref[min(n, (ll)i) - 1] - pref[lft[i] - 2] + mod) % mod;
        }
        pref[i] = (pref[i - 1] + dp[i]) % mod;
    }
    return dp[start + n - 1];
}

signed main() {
#ifndef LOCAL
    ios_base::sync_with_stdio(false); cin.tie(NULL);
#endif // LOCAL

    cin >> n >> k;
    for(ll i = 1; i <= n; i ++) {
        cin >> cnt[i];
        cnt[n + i] = cnt[i];
    }

    reset();
    ll l = 1;
    for(ll r = 1; r <= 2 * n; r ++) {
        add(r, 1);
        while(good.empty()) {
            add(l, -1);
            l ++;
        }
        lft[r] = l;
    }

    if(lft[n] == 1) {
        cout << (fpow(2, n) - n + mod) % mod << endl;
        return 0;
    }

    ll ret = 0;
    for(int i = 1; i <= n; i ++) {
        ret = (ret + solve_slow(i)) % mod;
    }
    cout << ret << endl;

    return 0;
}

