///#include "Lgrader.cpp"
#include "maxpath.h"
#include <iostream>
#define endl '\n'
using namespace std;

int n;
int a[200005];
int tree[400005];

void build(int v, int l, int r)
{
    if (l == r)
    {
        tree[v] = a[l];
        return;
    }

    int mid = (l + r) / 2;
    build(2 * v, l, mid);
    build(2 * v + 1, mid + 1, r);
    tree[v] = max(tree[2 * v], tree[2 * v + 1]);
}

int query(int v, int l, int r, int L, int R)
{
    if (r < L or R < l) return 1e9;
    if (L <= l and r <= R) return tree[v];

    int mid = (l + r) / 2;
    return max(query(2 * v, l, mid, L, R), query(2 * v + 1, mid + 1, r, L, R));
}

int ask_judge(int a, int b);

void learn(int n0)
{
    n = n0;
    for (int i = 1; i < n; ++ i)
    {
        a[i] = ask_judge(i, i + 1);
    }

    build(1, 1, n - 1);
}

int ask_contestant(int a, int b)
{
    if (a > b) swap(a, b);
    return query(1, 1, n - 1, a, b - 1);
}
