#include <bits/stdc++.h>
#include "maxpath.h"
using namespace std;

const int MAXN = 2e5+5;
int N;

int t[3000][3000];

int tree[4 * MAXN];
void update(int L, int R, int node, int ind, int val)
{
    if (L > ind || R < ind) return;
    if (L == R)
    {
        tree[node] += val;
        return;
    }
    int mid = (L + R) / 2;

    update(L, mid, node*2, ind, val);
    update(mid+1, R, node*2+1, ind, val);

    tree[node] = max(tree[node*2],  tree[node*2+1]);
}

int query(int L, int R, int node, int beg, int en)
{
    if (L > en || R < beg) return 0;
    if (L >= beg && R <= en) return tree[node];
    int mid = (L+R)/2;
    return max(query(L, mid, node*2, beg, en), query(mid+1, R, node*2+1, beg, en));
}

void learn(int n)
{
    N = n;
    for (int i = 1; i < n; i++)
    {
        update(1, n, 1, i, ask_judge(i, i+1));
    }
}

int ask_contestant(int a, int b)
{
    return query(1, N, 1, a, b-1);
}
