#include<bits/stdc++.h>
#include "maxpath.h"
#pragma GCC optimize("O3")
using namespace std;
const int MAX_N = 2e5+5;
int tree[MAX_N*4];
int N;
void build(int node, int tl, int tr)
{
    if(tl == tr)
    {
        cout<<tl<<" "<<tr<<endl;
        tree[node] = ask_judge(tl,tl+1);
        return;
    }
    int mid = (tl+tr)/2;
    build(node*2, tl, mid);
    build(node*2+1, mid+1, tr);
    tree[node] = max(tree[node*2], tree[node*2+1]);
}
int query(int node, int tl, int tr, int l, int r)
{
    if(tl > r || tr < l) return 0;
    if(tl >= l && tr <= r)
    {
        return tree[node];
    }
    int mid = (tl+tr)/2;
    return max(query(node*2, tl, mid, l, r), query(node*2+1, mid+1, tr, l ,r));
}
void learn(int n)
{
    N = n;
    build(1,1,N-1);
}
int ask_contestant(int a, int b)
{
    if(a > b) swap(a,b);
    return query(1,1,N-1,a,b-1);
}
/**
7
6 3 5 2 6 1
6 6 6 4 6
5 3 6 3
5 6 5
6 2
6
*/
