#include<bits/stdc++.h>
#include "maxpath.h"
#define MAXN1 2002
#define MAXN2 2000002
using namespace std;
int all[MAXN1][MAXN1], caseNum, st[MAXN2][64], N;
int path[MAXN2];
void case1()
{
    for(int i = 1; i <= N; i ++)
    {
        for(int j = 1; j <= N; j ++)
        {
            if(i != j) all[i][j] = all[j][i] = ask_judge(i, j);
        }
    }
}
void case2()
{
    for(int i = 2; i <= N; i ++)
    {
        path[i] = ask_judge(i, i - 1);
    }
}
void build_sparse()
{
    for(int i = 1; i <= N; i ++)
    {st[i][0] = path[i]; /*cout<<i<<" "<<st[i][0]<<endl;*/}
    for(int i = 1; (1 << i) <= N; i ++)
    {
        for(int j = 1; j + (1 << i) - 1 <= N; j ++)
        {
            st[j][i] = max(st[j][i - 1], st[j + (1 << (i - 1))][i - 1]);
        }
    }
}
int findPW(int p)
{
    if(p == 0) return 0;
    int pw = 0;
    while(p)
    {
        pw ++;
        p /= 2;
    }
    return pw - 1;
}
int sparse_queries(int l, int r)
{
    l ++;
    int sz = findPW(r - l + 1);
    //int sz = 0;
    //cout<<sz<<endl;
    //cout<<st[l][sz]<<" "<<st[r - (1 << (sz)) + 1][sz]<<endl;
    return max(st[l][sz], st[r - (1 << (sz)) + 1][sz]);
}
void learn(int n)
{
    N = n;
    if(n < MAXN1)
    {
        case1();
        caseNum = 1;
    }
    else
    {
        case2();
        caseNum = 2;
        build_sparse();
    }

}
int ask_contestant(int a, int b)
{
    if(a > b) swap(a, b);
    if(a == b) return 0;
    if(caseNum == 1) return all[a][b];
    else return sparse_queries(a, b);
}
/*
6
10 10 10 10 10
1 3 8 8
3 8 8
8 8
4
15
6 1
6 2
6 3
6 4
6 5
5 1
5 2
5 3
5 4
4 1
4 2
4 3
3 1
3 2
2 1
*/

