#include<bits/stdc++.h>
#include "maxpath.h"
#define MAXN1 2002
#define MAXN2 2000002
using namespace std;
int all[MAXN1][MAXN1], caseNum, st[MAXN2][64], N, ans[MAXN2];
int path[MAXN2];
bool occ[MAXN2], cannot[MAXN2], found;
void case1()
{
    for(int i = 1; i <= N; i ++)
    {
        for(int j = 1; j <= N; j ++)
        {
            if(i != j) all[i][j] = all[j][i] = ask_judge(i, j);
        }
    }
}
void case2()
{
    for(int i = 2; i <= N; i ++)
    {
        path[i] = ask_judge(i, i - 1);
        if(occ[path[i]])
        {
            caseNum = 3;
            return;
        }
        else occ[path[i]] = 1;
    }
}
void build_sparse()
{
    for(int i = 1; i <= N; i ++)
    {st[i][0] = path[i]; /*cout<<i<<" "<<st[i][0]<<endl;*/}
    for(int i = 1; (1 << i) <= N; i ++)
    {
        for(int j = 1; j + (1 << i) - 1 <= N; j ++)
        {
            st[j][i] = max(st[j][i - 1], st[j + (1 << (i - 1))][i - 1]);
        }
    }
}
int findPW(int p)
{
    if(p == 0) return 0;
    int pw = 0;
    while(p)
    {
        pw ++;
        p /= 2;
    }
    return pw - 1;
}
int sparse_queries(int l, int r)
{
    l ++;
    int sz = findPW(r - l + 1);
    //int sz = 0;
    //cout<<sz<<endl;
    //cout<<st[l][sz]<<" "<<st[r - (1 << (sz)) + 1][sz]<<endl;
    return max(st[l][sz], st[r - (1 << (sz)) + 1][sz]);
}
void opit(int v)
{
    memset(occ, 0, sizeof occ);
    for(int i = 1; i <= N; i ++)
    {
        if(i != v && !cannot[i])
        {
            int e = ask_judge(v, i);
            if(occ[e])
            {
                cannot[v] = 1;
                return;
            }
            else occ[e] = 1;
        }
    }
    found = 1;
}
void findAns(int v)
{
    for(int i = 1; i <= N; i ++)
    {
        if(i != v)
        {
            ans[i] = ask_judge(i, v);
        }
    }
    ans[v] = 0;
}
void case3()
{
    int ind = 0;
    while(!found)
    {
        ind ++;
        opit(ind);
    }
    findAns(ind);

}
void learn(int n)
{
    N = n;
    if(n < MAXN1)
    {
        case1();
        caseNum = 1;
    }
    else
    {
        case2();
        if(caseNum == 3)
        {
            case3();
        }
        else
        {
            caseNum = 2;
            build_sparse();
        }

    }

}
int ask_contestant(int a, int b)
{
    if(a > b) swap(a, b);
    if(a == b) return 0;
    if(caseNum == 1)
    {cout<<a<<" "<<b<<": "<<all[a][b]<<endl;return all[a][b];}
    else if(caseNum == 2) return sparse_queries(a, b);
    else return max(ans[a], ans[b]);
}
/*
6
10 10 10 10 10
1 3 8 8
3 8 8
8 8
4
15
6 1
6 2
6 3
6 4
6 5
5 1
5 2
5 3
5 4
4 1
4 2
4 3
3 1
3 2
2 1

5
4 3 2 1
4 4 4
3 3
2
10
1 2
1 3
1 4
1 5
2 3
2 4
2 5
3 4
3 5
4 5
*/

